use super::greater_element::DynamicBlock;
use super::greater_element::FootnoteDefinition;
use super::greater_element::PlainList;
use super::greater_element::PropertyDrawer;
use super::greater_element::Table;
use super::lesser_element::BabelCall;
use super::lesser_element::Clock;
use super::lesser_element::Comment;
use super::lesser_element::CommentBlock;
use super::lesser_element::DiarySexp;
use super::lesser_element::ExampleBlock;
use super::lesser_element::ExportBlock;
use super::lesser_element::FixedWidthArea;
use super::lesser_element::HorizontalRule;
use super::lesser_element::Keyword;
use super::lesser_element::LatexEnvironment;
use super::lesser_element::Paragraph;
use super::lesser_element::Planning;
use super::lesser_element::SrcBlock;
use super::lesser_element::VerseBlock;
use super::CenterBlock;
use super::Drawer;
use super::GetStandardProperties;
use super::QuoteBlock;
use super::SpecialBlock;
use super::StandardProperties;

#[allow(clippy::large_enum_variant)]
#[derive(Debug)]
pub enum Element<'s> {
    Paragraph(Paragraph<'s>),
    PlainList(PlainList<'s>),
    CenterBlock(CenterBlock<'s>),
    QuoteBlock(QuoteBlock<'s>),
    SpecialBlock(SpecialBlock<'s>),
    DynamicBlock(DynamicBlock<'s>),
    FootnoteDefinition(FootnoteDefinition<'s>),
    Comment(Comment<'s>),
    Drawer(Drawer<'s>),
    PropertyDrawer(PropertyDrawer<'s>),
    Table(Table<'s>),
    VerseBlock(VerseBlock<'s>),
    CommentBlock(CommentBlock<'s>),
    ExampleBlock(ExampleBlock<'s>),
    ExportBlock(ExportBlock<'s>),
    SrcBlock(SrcBlock<'s>),
    Clock(Clock<'s>),
    DiarySexp(DiarySexp<'s>),
    Planning(Planning<'s>),
    FixedWidthArea(FixedWidthArea<'s>),
    HorizontalRule(HorizontalRule<'s>),
    Keyword(Keyword<'s>),
    BabelCall(BabelCall<'s>),
    LatexEnvironment(LatexEnvironment<'s>),
}

impl<'s> GetStandardProperties<'s> for Element<'s> {
    fn get_standard_properties<'b>(&'b self) -> &'b dyn StandardProperties<'s> {
        match self {
            Element::Paragraph(inner) => inner,
            Element::PlainList(inner) => inner,
            Element::CenterBlock(inner) => inner,
            Element::QuoteBlock(inner) => inner,
            Element::SpecialBlock(inner) => inner,
            Element::DynamicBlock(inner) => inner,
            Element::FootnoteDefinition(inner) => inner,
            Element::Comment(inner) => inner,
            Element::Drawer(inner) => inner,
            Element::PropertyDrawer(inner) => inner,
            Element::Table(inner) => inner,
            Element::VerseBlock(inner) => inner,
            Element::CommentBlock(inner) => inner,
            Element::ExampleBlock(inner) => inner,
            Element::ExportBlock(inner) => inner,
            Element::SrcBlock(inner) => inner,
            Element::Clock(inner) => inner,
            Element::DiarySexp(inner) => inner,
            Element::Planning(inner) => inner,
            Element::FixedWidthArea(inner) => inner,
            Element::HorizontalRule(inner) => inner,
            Element::Keyword(inner) => inner,
            Element::BabelCall(inner) => inner,
            Element::LatexEnvironment(inner) => inner,
        }
    }
}
